=== tests/src/Base/CMakeLists.txt ===
target_sources(
    Tests_run
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/Bitmask.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Matrix.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Quantity.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Reader.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Rotation.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Unit.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/Writer.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/tst_Tools.cpp
)
